/************************************************************************/
/*                                                                      */
/* Defines file         for Jxx ARM Programming purposes (c) NiMar 2003 */
/*                                                                      */
/************************************************************************/
/* Portability Area                                                     */
/* put functions and other stuff addresses here to keep more portable   */
/* the code! For other fw, just change the equ to correct values!       */
/*                                                                      */
/* Established by Bodhi3                                                */
/* Added functions for J7/70 3.10_4 by NiMar  nimar@mail.rb.ru          */
/************************************************************************/
.ifdef J7_3.10_4
     /*      J7/70 FW:3.10/4 Lib        */
     /* By NiMar                        */
     .equ    ver,            0x20031004

     /* Some Address in FW */
     .equ    wallAddr,       0x86a677        /* Current wallpaper address */
     .equ    mannerAddr,     0x865c00        /* Current manner address */
     .equ    askptAddr,      0x876164        /* *#ASKPT1x value adrress */
     .equ    IMSIAddr,       0x875A08
     .equ    videoMem,       0x0301BD2C      /* VideoMemory address */
     .equ    MSGBEvAddr,     0x00358500      /* MSG Big Event Address */
     .equ    MSGSEvAddr,     0x00358650      /* MSG Small Event Address */

     /* some stuff used by PRG Loader 2 */
     .equ    menuIconID,     0xE836
     .equ    bigEvAddr,      videoMem-0x20
     .equ    smallEvAddr,    videoMem-0x1C
     .equ    menuAddr,       videoMem-0x18
     .equ    TimerAddr,      0x0085E254

     /* Functions    */

     .equ    free_SG,                0x00A0AC9 /*SG's free*/
     .equ    LogPrintF_root,         0x018E825
.else
     .err    /* Other fw version */
.endif

/************************************************************************/
/*                                                                      */
/* FW functions Libraries                                               */
/*                      for Jxx ARM Programming purposes (c) NiMar 2003 */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/*  Usage: To use functions include .xdef <libname> string in your      */
/*         program                                                      */
/*                                                                      */
/*    <libname> can be:                                                 */
/*        DISPLAY - memory management functions                         */
/*        MEMORY  - memory management functions                         */
/*        STRINGS - strings functions                                   */
/*        NVM       NVM functions                                       */
/*        WINDOWS   windows functions                                   */
/*        MENU_EV   Menu Events functions                               */
/*        MONITOR   Monitor Mode function                               */
/*        DEBUG     Debug functions                                     */
/*                                                                      */
/*                                             NiMar  nimar@mail.rb.ru  */
/************************************************************************/
.macro MyExternalFunc Name Address
.\Name:
  push  {r0-r1}
  ldr   r0,_\Name
  str   r0,[sp,#4]
  pop   {r0,pc}
_\Name:
    .word \Address
.endm


/************************************************************************/
/* FW dislpay management functions                                      */
/************************************************************************/
.ifdef DISPLAY
.align 2
.equ RepaintAddr,0x00CADE5
MyExternalFunc DisplayRefresh 0x00CB38D
.repaint:
  push {LR}
  mov  r0,#0
  bl    .DisplayRefresh
  pop  {PC}

.Light:   @ r0=0..ff current intensity
        PUSH    {r1, LR}
        ldr     r1,light  
        strb    r0,[r1]
        POP     {r1, PC}          

.LightOff:
        PUSH    {r0-r1, LR}
                LDR     R0, light
                MOV     R1, #0
                STRB    R1, [R0]
        POP     {r0-r1, PC}          

.FadeLightOff:
        PUSH    {r0-r2, LR}
                LDR     R0, light
                LDRB    R1, [R0]
                CMP     R1, #0
                BEQ     FadeLightOff_exit
                LDR     R1, MaxLightIntAdr
                LDRB    R1, [R1]

loop_light:
                STRB    R1, [R0]
                LDR     R2, FadeInterval

loop_interval:
                SUB     R2, #1
                CMP     R2, #0
                BNE     loop_interval
                SUB     R1, #1
                CMP     R1, #0
                BNE     loop_light
FadeLightOff_exit:
        POP     {r0-r2, PC}          

.align 2
light:          .word 0xFFFE8000
MaxLightIntAdr: .word   0x00248130    @ Address where is max intensity value (ex. 0xFF with Extralight)
FadeInterval:   .word   0xC00
.endif

/************************************************************************/
/* FW memory management functions                                       */
/************************************************************************/
.ifdef MEMORY
.align 2
MyExternalFunc memset 0x01D6B87
MyExternalFunc malloc 0x024A9AD
MyExternalFunc free   0x00A0AC9
MyExternalFunc memcpy 0x0011079
@MyExternalFunc free   0x024A9DD
.endif

/************************************************************************/
/* FW strings functions                                                 */
/************************************************************************/
.ifdef STRINGS
.align 2
.WString_MakeFromAscii:
MyExternalFunc WStr_MakeFA 0x005ADF9

.WString_Destroy:
MyExternalFunc WStr_Destroy 0x005AEF1
MyExternalFunc IntToWStr 0x01F4339
/* sprintf(target_adr,text,?,?) - other params in SP */
MyExternalFunc sprintf 0x018E72B
.endif

/************************************************************************/
/* FW NVM functions                                                     */
/************************************************************************/
.ifdef NVM
.align 2
MyExternalFunc NVMGetSection 0x00FCDC1
MyExternalFunc NVMReadSection 0x00FD1FB
MyExternalFunc NVMCloseSection 0x00FCFA1
MyExternalFunc NVMWriteSection 0x00FD345
MyExternalFunc NVMEraseSection 0x00FD019
MyExternalFunc NVMGetSectionSize 0x00FD71D
.endif

/************************************************************************/
/* FW windows functions                                                 */
/*    Uses:                                                             */
/*         strings functions                                            */
/*         memory  functions                                            */
/************************************************************************/
.ifdef WINDOWS
.align 2
MyExternalFunc GetWindowManager 0x001f544b     @ some address J5 0x86A4F4 -> J7 0x87AB24
.GetWindowById:
MyExternalFunc GetWindowHandle 0x018AD41
.cWindowWidget_Create:
MyExternalFunc WindowWidget_Create 0x0018cded
.WindowWidget_Destroy:
MyExternalFunc CloseWindow 0x18AAF3
MyExternalFunc WindowWidget_KeyEvent 0x18D18D
MyExternalFunc MessageWindow 0x00E81F1
MyExternalFunc WindowWidget_SetTimer 0x018D025
MyExternalFunc CreateMonitorWindow 0x023BEAD
MyExternalFunc MonWND_AddLine 0x01CA0C7
MyExternalFunc WindowRepaint 0x001FC54D 

/***************************************************************************/
/* WNDsetpos (object,x,y) - Set top left corner position of any widget obj.*/
/***************************************************************************/
.WNDsetpos: push      {lr}  /* r0 = obj  r1 = X  r2 = Y  */
            strh      r1,[r0,#0x4]
            strh      r2,[r0,#0x6]
            pop       {pc}

/***************************************************************************/
/* WNDsetsize (object,width,height) - Set any widget object size           */
/***************************************************************************/
.WNDsetsize: push      {lr}  /* r0 = obj  r1 = width  r2 = height  */
             strh      r1,[r0,#0x8]
             strh      r2,[r0,#0xA]
             pop       {pc}

   /********************************************************/
   /* InfoBox(handle,text,time,type)                       */
   /*   handle=Parent WND handle                           */
   /*   text=ASCII null-terminated text (\n for new line)  */
   /*   time=Time to live in ms (0=no timer)               */
   /*   type=Type of dialog (0,3,4,5,6,7)                  */
   /********************************************************/
/*.align 2
.InfoBox:
        push    {r3-r7,LR}
        sub     sp,sp,#0x14
        str     r0,[sp]
        str     r1,[sp,#4]
        str     r2,[sp,#8]
        mov     r5,r3

        mov     r0,#0x68
        bl      .malloc
        mov     r6,r0

        add     r0,sp,#0xC
        ldr     r1,[sp,#4]
        mov     r2,#2
        bl      .WString_MakeFromAscii
        mov     R7, R0
       
        mov     r0,r6
        ldr     r1,[sp]
        add     r2,sp,#0xC
        mov     r3,r5

        push    {r7}
        STR     R7, [SP]
        MOV     R4, #1
        MOV     R7, SP
        STRB    R4, [R7,#4]
        bl      .MessageWindow
        pop     {r7}

        add     r0,sp,#0xC
        mov     r1,#2
        bl      .WString_Destroy

        mov     r0,r6
        ldr     r1,[sp,#8]
        cmp     r1,#0
        beq     .InfoBox_notimer
        bl      .WindowWidget_SetTimer
.InfoBox_notimer:

        add     sp,sp,#0x14
        pop     {r3-r7,PC}
*/

   /********************************************************/
   /* InfoBoxNew(handle,text,fullscreen{0,1},type)         */
   /*   handle=Parent WND handle                           */
   /*   text=ASCII null-terminated text (\n for new line)  */
   /*   type=Type of dialog (0,3,4,5,6,7)                  */
   /********************************************************/
.align 2
.InfoBoxNew:     @ FullScreen!!!
        push    {r3-r7,LR}
        sub     sp,sp,#0x14
        str     r0,[sp]
        str     r1,[sp,#4]
        str     r2,[sp,#8]
        mov     r5,r3

        mov     r0,#0x68
        bl      .malloc
        mov     r6,r0

        add     r0,sp,#0xC
        ldr     r1,[sp,#4]
        mov     r2,#2
        bl      .WString_MakeFromAscii
        mov     R7, R0
       
        mov     r0,r6
        ldr     r1,[sp]
        add     r2,sp,#0xC
        mov     r3,r5

        push    {r7}
        STR     R7, [SP]
        MOV     R4, #1
        MOV     R7, SP
        STRB    R4, [R7,#4]
        bl      .MessageWindow
        pop     {r7}

        add     r0,sp,#0xC
        mov     r1,#2
        bl      .WString_Destroy

        ldr     r0,[sp,#8]
        cmp     r0,#1
        bne     .InfoBox_end

        ldr     r1,[sp,#8]
        mov     r1,#0
        mov     r2, r1
        STRH    R1, [R6,#4]
        STRH    R2, [R6,#6]
        mov     r0,r6
        mov     r1, #0x60          @ width
        mov     r2, #0x5C          @ height
        STRH    R1, [R6,#8]
        STRH    R2, [R6,#0xA]
 
.InfoBox_end:

        add     sp,sp,#0x14
        pop     {r3-r7,PC}

.endif

/************************************************************************/
/* FW Menu Events functions                                             */
/************************************************************************/
.ifdef MENU_EV
.align 2
MyExternalFunc InitializeListMenu 0x0243D55

.GetMenuListObj:
MyExternalFunc sub_0_261E9C 0x0243DBD

.DestroyListMenu:
MyExternalFunc sub_0_261EAE 0x0243DCF

.CreateListMenuItems:
MyExternalFunc ListMenuSetItems 0x01BC5DD


.SetListCallback:
MyExternalFunc sub_0_126B30 0x0105419

.DestroyListItems:
MyExternalFunc sub_0_256C54 0x023A8BD

.GetListSelectedId:
MyExternalFunc GetMenuEvent 0x0105109
.endif

/************************************************************************/
/* FW Monitor Mode function                                             */
/************************************************************************/
.ifdef MONITOR
.align 2
MyExternalFunc Monitor_Menu 0x01E8E8D
.endif

/************************************************************************/
/* FW Timer function                                                    */
/************************************************************************/
.ifdef TIMER
.align 2
MyExternalFunc MIPS 0x01EC6B9
MyExternalFunc Time_CreateServer 0x00233673  @ J5 379330 -> J7 369924
MyExternalFunc Time_DestroyServer 0x002336A5 
MyExternalFunc Time_SetInterval 0x002336D7 
MyExternalFunc Time_Repeat 0x00233771 
.SetTimerMsec:
  push  {lr}
  ldr   r3,TimerMulConst
  lsr   r2,r1,#17
  mul   r2,r3

  lsl   r1,#15
  lsr   r1,#15
  mul   r1,r3

  mov   r3,#1
  lsl   r3,#16

  add   r1,r3
  lsr   r1,#17

  add   r1,r2

  mov   r2,#1
  bl    .Time_SetInterval
  pop   {pc}

.align 2
  TimerMulConst:        .word   28398

.endif

/************************************************************************/
/* NiMar's Delay                                                        */
/************************************************************************/
.ifdef NIMAR_DELAY
.align 2
  /********************************************************/
  /* Delay(interval(ms), multiplier, constant)            */
  /* return Pressed Key ID or FF else                     */
  /********************************************************/ 
.DelayButKey:
         PUSH   {R1-R4,LR}
                mov     r3, r0
                mul     r3, r1
                add     r3, #1
         delay_loop0:

                mov     r4, r2
           loop0__:     

                bl      .IsNumButton
                cmp     r0, #0xFF
                bne     key_pressed_delay         

                sub     r4, #1
                cmp     r4, #0
                bne     loop0__

                sub     r3, #1
                cmp     r3, #0
                bne     delay_loop0

key_pressed_delay:
         POP    {R1-R4,PC}

  /********************************************************/
  /* Delay(interval(ms), multiplier, constant)            */
  /********************************************************/ 
.Delay:
         PUSH   {R1-R4,LR}
                mov     r3, r0
                mul     r3, r1
                add     r3, #1
         delay_loop1:

                mov     r4, r2
           loop1__:     
                sub     r4, #1
                cmp     r4, #0
                bne     loop1__

                sub     r3, #1
                cmp     r3, #0
                bne     delay_loop1
         POP    {R1-R4,PC}

.endif

/************************************************************************/
/* FW Direct Keyboard function                                          */
/************************************************************************/
.ifdef DIRECT_KEYBOARD
.align 2

.IsRedButton:
         PUSH    {R1-R3,LR}
                mov     r0, #0
                ldr     r2,key2         
                ldrb    r1,[r2]         
                cmp     r1,#0x4         
                bne     no_button
                mov     r0, #1
            no_button:
         POP    {R1-R3,PC}

.IsNumButton:
         PUSH    {R1-R3,LR}
                ldr     r1,key1 
                ldrb    r1,[r1]         

                ldr     r0,key0 
                ldrb    r0,[r0]         
                bl      .GetButtonId
         POP    {R1-R3,PC}

.WaitForKey:
         PUSH    {R1-R3,LR}
w_key:
                ldr     r2,key2 
                ldrb    r2,[r2]         

                ldr     r1,key1 
                ldrb    r1,[r1]         

                ldr     r0,key0 
                ldrb    r0,[r0]         
                bl      .GetButtonId
                cmp     r0, #0xff
                beq     w_key
         POP    {R1-R3,PC}

  /********************************************************/
  /* GetButtonId(key0, key1, key2)                        */
  /********************************************************/ 
.GetButtonId:
         PUSH    {R1-R5,LR}
                mov     r3, r0
                cmp     r1,#0x10         
                bne     next_button2
                mov     r0, #1
                b       no_button0
          next_button2:
                cmp     r1,#0x20         
                bne     next_button3
                mov     r0, #2
                b       no_button0
          next_button3:
                cmp     r1,#0x40         
                bne     next_button4
                mov     r0, #3
                b       no_button0
          next_button4:
                cmp     r1,#0x1         
                bne     next_button5
                mov     r0, #4
                b       no_button0
          next_button5:
                cmp     r1,#0x2
                bne     next_button6
                mov     r0, #5
                b       no_button0
          next_button6:
                cmp     r1,#0x4
                bne     next_button7
                mov     r0, #6
                b       no_button0
          next_button7:

                mov     r1, r3
                cmp     r1,#0x10
                bne     next_button8
                mov     r0, #7
                b       no_button0
          next_button8:
                cmp     r1,#0x20
                bne     next_button9
                mov     r0, #8
                b       no_button0
          next_button9:
                cmp     r1,#0x40
                bne     next_buttonAST
                mov     r0, #9
                b       no_button0
          next_buttonAST:
                cmp     r1,#0x1
                bne     next_button0
                mov     r0, #10           @ * - button
                b       no_button0
          next_button0:
                cmp     r1,#0x2
                bne     next_buttonNUM
                mov     r0, #0
                b       no_button0
          next_buttonNUM:
                cmp     r1,#0x11          @ # - button
                bne     next_button00
                mov     r0, #0
                b       no_button0

          next_button00:
                mov     r0, #0xFF
          no_button0:
         POP    {R1-R5,PC}


.align 2
key0: .word 0x87A3E0 @  1 - "*"
                     @  2 - "0"
                     @  4 - "#"
                     @ 10 - "7"
                     @ 20 - "8"
                     @ 40 - "9"

key1: .word 0x87A3E1 @  1 - "4"
                     @  2 - "5"
                     @  4 - "6"
                     @ 10 - "1"
                     @ 20 - "2"
                     @ 40 - "3"

key2: .word 0x87A3E2 @  1 - GreenButton
                     @  2 - CenterButton
                     @  4 - RedButton
                     @  8 - Jog Press
.endif

/************************************************************************/
/* FW Direct Communication functions                                    */
/************************************************************************/
.ifdef DIRECT_COMM
  /********************************************************/
  /* SendCR                                               */
  /********************************************************/ 
.align 2
.SendCR:          
         PUSH   {R0-R1,LR}
                ldr     r1, 0xFFFF5800
                mov     r0,#0x0D     
                strb    r0,[r1]
                mov     r0,#0x0A
                strb    r0,[r1]
         POP    {R0-R1,PC}

  /********************************************************/
  /* SendByte(byte)                                       */
  /********************************************************/ 
.align 2
.SendByte:          
         PUSH   {R1,LR}
                ldr     r1, 0xFFFF5800
                strb    r0,[r1]      
         POP    {R1,PC}

.align 2
ComAddr: .word 0xFFFF5800
.endif

/************************************************************************/
/* FW Debug functions                                                   */
/************************************************************************/
.ifdef DEBUG
.align 2
MyExternalFunc CTEDebugPrintF 0x018E7D3
  /********************************************************/
  /* LogPrintF(string,param1,param2,param3)               */
  /*   string=ASCII null-terminated text (\n for new line)*/
  /*   param1..3=printf parameters                        */  
  /********************************************************/ 
.LogPrintF:
.printf:
         PUSH    {R0-R3}
         PUSH    {R7,LR}
         ADD     R7, SP, #8
         SUB     SP, SP, #4

         ADD     R0, R7, #0
         ADD     R0, #4
         LSR     R0, R0, #2
         LSL     R0, R0, #2
         STR     R0, [SP]
         LDR     R0, [R7]
         LDR     R1, [SP]
         BL      .CTEDebugPrintF

         ADD     SP, SP, #4
         POP     {R7}
         POP     {R2}
         ADD     SP, SP, #0x10
         MOV     PC, R2

.endif


/************************************************************************/
/* FW Debug functions                                                   */
/************************************************************************/
.ifdef EDITBOX

 MyExternalFunc sub_1F544A 0x1F544B  @ some func1 
 MyExternalFunc sub_18CDEC 0x18CDED  @ some func2 R0-POEW
 MyExternalFunc sub_5AC44 0x05AC45  @  Write zeroes at [SP+0x18] 8 bytes.
                                     @  Maybe allocate Empty WString
 MyExternalFunc sub_5B418 0x05B419  @ Some WStr functionMaybe WStrCpy
                                     @ R0 - result WString address
                                     @ R1 - input WString
 MyExternalFunc EditBox 0x22C7A1     @ Create EditBox
                                     @ R0 = PEBO
                                     @ R1 = SP = Pointer to MaskWString
 MyExternalFunc sub_22C780 0x22C781  @ Do smth witn string
                                     @ R0 = PEBO
                                     @ R1 = Pointer to timestring
 MyExternalFunc sub_178E3E 0x178E3F  @ Get smth from it
 MyExternalFunc sub_178FF6 0x178FF7  @ Maybe copy functable1
 MyExternalFunc sub_178FC4 0x178FC5  @ Maybe copy functable2
 MyExternalFunc sub_5AE3C 0x05AE3D  @ Maybe Create WString from ID
 MyExternalFunc sub_135DEE 0x135DEF  @ Copy it at SP+0x10
 MyExternalFunc sub_120BA6 0x120BA7  @ Add it to object !!!!!
 MyExternalFunc sub_20EAF2 0x20EAF3  @ do smth with EBO
 MyExternalFunc sub_23A4E4 0x23A4E5  @ DestroyWindowItems1
 MyExternalFunc sub_23A6D0 0x23A6D1  @ DestroyWindowItems2
 MyExternalFunc sub_18D300 0x18D301  @ DestroyWindow
.endif

/************************************************************************/
/* DIV / MOD random generator                                           */
/************************************************************************/
.ifdef RANDOM
.DivMod:
.divmod:
        MOV     r2,r1
        MOV     r1,r0
        MOV     r0,#0
.divloop:
        CMP     r1,r2
        BLO     .divend
        SUB     r1,r2
        ADD     r0,#1
        B       .divloop
.divend:
        MOV     PC,LR
/**************************************************/
.InitRandom:
.initseed: PUSH  {r0-r1,LR}
          LDR   r0,counter
          LDR   r0,[r0]
          ADR   r1,seed
          STR   r0,[r1]
          POP   {r0-r1,PC}
/**************************************************/
.Random:
.random: PUSH    {r1-r6,LR}
         MOV     r1,r0
         LDR     r0,seed
         LDR     r2,num1
         MUL     r0,r2
         LDR     r2,num2
         ADD     r0,r2
         ADR     r2,seed
         STR     r0,[r2]
         LSR     r0,#16
         BL      .divmod
         MOV     r0,r1
         POP     {r1-r6,PC}

.align 2
seed:    .word 0x12345678
num1:    .word 214013
num2:    .word 2531011
counter: .word TimerAddr @84D98C       /* Phone counter - base for random */
.endif

/************************************************************************/
/* FW GFX routines                                                      */
/************************************************************************/
.ifdef GFX
MyExternalFunc GetFontStruct 0x14b3eb /*0x1680CF*/ @ 0x8641a0 -> 0x8746d4 
MyExternalFunc GFX_FillRect 0xB5D1B
MyExternalFunc GFX_Frame 0xB5F9D
MyExternalFunc GFX_WriteText 0x0b61f7 /*0x0D384F*/
   /********************************************************/
   /* WriteText(handle, x, y, text, font&color)            */
   /*   handle=Parent WND handle                           */
   /*   text=ASCII null-terminated text (\n for new line)  */
   /********************************************************/
.align 2
.WriteText:
  push  {r4-r7,lr}      @ GFX,x,y,text,font&color
  sub   sp,#0x14
  mov   r7,r4
  mov   r4,r0
  mov   r5,r1
  mov   r6,r2

  add   r0,sp,#0xC
  mov   r1,r3
  mov   r2,#2
  bl    .WString_MakeFromAscii

  mov   r0,#0
  str   r0,[sp]

  mov   r0, r7
  lsl   r0, #16
  lsr   r0, #16
  bl    .GetFontStruct  @ Get font #6 - standard
  str   r0,[sp,#4]

  mov   r0,#0
  str   r0,[sp,#8]

  lsr   r0, r7, #16
  str   r0,[sp]

  mov   r0,r4
  mov   r1,r5
  mov   r2,r6
  add   r3,sp,#0xC
  bl    .GFX_WriteText  @(GFX,X,Y,WString,0,Font,0)

  add   r0,sp,#0xC
  mov   r1,#2
  bl    .WString_Destroy
  add   sp,#0x14
  pop   {r4-r7,pc}

.endif

/************************************************************************/
/* r00t's Video routines                                                */
/************************************************************************/
.ifdef ROOT_GFX
.getofs:                        /* r0=x r1=y out: r0=ofs - WORKING*/
        PUSH    {r2,LR}
        MOV     r2,#96
        MUL     r1,r2
        ADD     r0,r1
        LDR     r2,vm
        ADD     r0,r2
        POP     {r2,PC}
/**********************************************************************/
.putpix:
         PUSH    {r3-r6,LR}           /* r0=x r1=y r2=color   - WORKING*/
         BL      .getofs
         STRB    r2,[r0]
         POP     {r3-r6,PC}
/**********************************************************************/
.hline:                         /* r0=x r1=y r2=length r3=color */
        PUSH    {r4-r6,LR}
        BL      .getofs
.hlineloop:
        STRB    r3,[r0]
        ADD     r0,#1
        SUB     r2,#1
        CMP     r2,#0
        BNE     .hlineloop
        POP     {r4-r6,PC}
/**********************************************************************/
.getpix:
        PUSH    {LR}
        BL      .getofs
        LDRB    r0,[r0]
        POP     {PC}
/**********************************************************************/
.clrscr:                  /* r0=color  - WORKING*/
        PUSH    {r1-r6,LR}
        MOV     r3,r0
        MOV     r0,#0
        MOV     r1,#0
        LDR     r2,vs
        BL      .hline
        POP     {r1-r6,PC}
/**********************************************************************/
.DrawScreen2bpp:        @ r0=Dest.Buffer, r1=Src.Buffer
  push  {r4-r5,lr}
  mov   r5,#0x8A
  lsl   r5,#4    @ 96*92/4 = 0x8A0
DSloop:
  ldrb  r4,[r1]

  lsl   r2,r4,#30
  lsr   r2,#6

  lsr   r3,r4,#2
  lsl   r3,#30
  lsr   r3,#14
  orr   r2,r3

  lsr   r3,r4,#4
  lsl   r3,#30
  lsr   r3,#22
  orr   r2,r3

  lsr   r4,#6
  orr   r2,r4

  str   r2,[r0]

  add   r1,#1
  add   r0,#4

  sub   r5,#1
  bne   DSloop

  pop   {r4-r5,pc}
/**********************************************************************/
.loadscreen:
        PUSH    {r0-r6,LR}
        MOV     r1,r0
        LDR     r0,vm
        LDR     r2,vs
        BL      .memcpy
        POP     {r0-r6,PC}
/**********************************************************************/
.loadscreen2bpp:
        PUSH    {LR}
        MOV     r1,r0
        LDR     r0,vm
        BL      .DrawScreen2bpp
        POP     {PC}
/**********************************************************************/





/**********************************************************************/
.DrawSprite:    push    {r0-r5,LR}      @ r0=screen ofs r1=sprite r2=in sprite ofs
                ldrb    r3,[r1]
                ldrb    r4,[r1,#1]
                add     r1,r2
_NextRow:       mov     r5,#0
_NextPixel:     ldrb    r2,[r1,#2]
                cmp     r2,#4           @ 4 - transparent color
                beq     _NoPutPixel
                strb    r2,[r0,r5]
_NoPutPixel:    add     r5,#1
                add     r1,#1
                cmp     r5,r3
                bne     _NextPixel
                add     r0,#96
                sub     r4,#1
                cmp     r4,#0
                bne     _NextRow
                pop     {r0-r5,PC}
/**********************************************************************/
.GetSprite:     push    {r0-r5,LR}      @ r0=screen ofs r1=sprite r2=in sprite ofs
                ldrb    r3,[r1]
                ldrb    r4,[r1,#1]
                add     r1,r2
_NextRow1:      mov     r5,#0
_NextPixel1:    ldrb    r2,[r0,r5]
                strb    r2,[r1,#2]
                add     r5,#1
                add     r1,#1
                cmp     r5,r3
                bne     _NextPixel1
                add     r0,#96
                sub     r4,#1
                cmp     r4,#0
                bne     _NextRow1
                pop     {r0-r5,PC}
/**********************************************************************/
.align 2
vm: .word videoMem
vs: .word 0x2280
.endif

.ifdef HARDWARE
.align 2
MyExternalFunc DisableWatchDog 0x2310C6 /*0x2302F3*/
                                        @ 0x85e7d4
MyExternalFunc PowerOff 0x0A58Eb
.endif

.ifdef SOUNDSYSTEM
.align 2
MyExternalFunc MelodyPlay 0x1F5837
.endif
