@***********************************************************************************************************
@***********************************************************************************************************
@***********************************************************************************************************
@******************[ SOKOBAN 0.8b +10 Levels ]*******************[-=Slayer=-]**********[ 24.04.2003 ]*******
@***********************************************************************************************************
@***********************************************************************************************************
@***********************************************************************************************************
.text
.code 16
.globl _start
.align 4
game_start:	.word	0x20031004
@		.word	0x20036005
.string "SOKOBAN 0.8b"					@ Program Name 15 chars max
.org 0x14
_start:		b	.main
@.xdef	DISPLAY						@ memory management functions
.xdef	MEMORY						@ memory management functionsne
.xdef	STRINGS						@ strings functions          
.xdef	NVM						@ NVM functions              
.xdef	WINDOWS						@ windows functions          
@.xdef	MENU_EV						@ Menu Events functions      
@.xdef	MONITOR						@ Monitor Mode function      
.xdef	TIMER						@ Timer function      
@.xdef	NIMAR_DELAY					@ Delay :) functions
@.xdef	DIRECT_KEYBOARD					@ Keyboard functions
@.xdef	DEBUG						@ Debug functions            
@.xdef	RANDOM
@.xdef	ROOT_GFX
.equ J7_3.10_4,0
.include "J70_NM_Lib.h"
@.equ J7_3.6_5,0
@.include "J7365SAW25_Lib.h"
@***********************************************************************************************************
@************************************[ Font procedures & functions ]****************************************
@***********************************************************************************************************
.align 2						@  in: r0=screen ofs r1=letter
.DrawOneLetter:	push	{r2-r7,LR}			@ out: r0=next letter ofs r1=letter size
		push	{r0}
		sub	r1,#32
		mov	r2,#7
		mul	r1,r2
		adr	r2,font
		ldrb	r6,[r2]
		add	r2,#1
		add	r1,r2				@ r1=letter ofs
		ldrb	r2,[r1]				@ r2=letter width
		add	r1,#1
		mov	r3,#1
_OneLetterLoop:	ldrb	r4,[r1]				@ r4=first row
		mov	r7,#0
		push	{r1-r2}
_NextPix:	mov	r5,r4
		lsr	r5,r7
		and	r5,r3
		cmp	r5,#0
		bne	_NoPutPix
		ldr	r5,font_color
		strb	r5,[r0,r2]
_NoPutPix:	add	r7,#1
		sub	r2,#1
		cmp	r2,#0
		bne	_NextPix
		pop	{r1-r2}
		add	r0,#96
		add	r1,#1
		sub	r6,#1
		cmp	r6,#0
		bne	_OneLetterLoop
		pop	{r0}
		add	r0,r2
		add	r0,#1
		mov	r1,r2
		pop	{r2-r7,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y r2=string
.DrawString:	push	{r0-r2,LR}			@ out: none
_DrawNextRow:	push	{r0-r1}
		mov	r3,#96
		sub	r3,r0
		bl	.GetOfs
_DrawNextLetter:ldrb	r1,[r2]
		add	r2,#1
		cmp	r1,#0
		beq	_toPOP
		cmp	r1,#47
		beq	_toNextRow
		bl	.DrawOneLetter
		sub	r3,r1
		cmp	r3,#15
		bgt	_DrawNextLetter
_toNextRow:	pop	{r0-r1}
		add	r1,#7
		cmp	r1,#86
		bgt	_exitDrawString
		b	_DrawNextRow
_toPOP:		pop	{r0-r1}
_exitDrawString:pop	{r0-r2,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y r2=string
.DrawMaskedText:push	{r3-r4,LR}			@ out: none
		mov	r3,#3
		adr	r4,font_color
		strb	r3,[r4]
		sub	r0,#1
		bl	.DrawString
		add	r0,#2
		bl	.DrawString
		sub	r0,#1
		sub	r1,#1
		bl	.DrawString
		add	r1,#2
		bl	.DrawString
		sub	r1,#1
		mov	r3,#0
		strb	r3,[r4]
		bl	.DrawString
		pop	{r3-r4,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y r2=number
.DrawNumber:	push	{r0-r5,LR}			@ out: none
		bl	.GetOfs
		mov	r1,r2
		cmp	r1,#0
		beq	_ZeroNumber
		mov	r3,r1
		adr	r4,numbers_base
		sub	r4,#4
_QuickNumber:	add	r4,#4
		ldr	r5,[r4]
		cmp	r3,r5
		blt	_QuickNumber
_NumberLoop:	ldr	r5,[r4]
		mov	r1,#0
_NumberInner:	cmp	r3,r5
		blt	_NumberSkip
		sub	r3,r5
		add	r1,#1
		b	_NumberInner
_NumberSkip:	push	{r1}
		add	r1,#48
		bl	.DrawOneLetter
		pop	{r1}
		add	r4,#4
		cmp	r5,#1
		bne	_NumberLoop
		b	_endWriteNumber
_ZeroNumber:	add	r1,#48
		bl	.DrawOneLetter
_endWriteNumber:pop	{r0-r5,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y r2=number
.DrawMaskedNum:push	{r3-r4,LR}			@ out: none
		mov	r3,#3
		adr	r4,font_color
		strb	r3,[r4]
		sub	r0,#1
		bl	.DrawNumber
		add	r0,#2
		bl	.DrawNumber
		sub	r0,#1
		sub	r1,#1
		bl	.DrawNumber
		add	r1,#2
		bl	.DrawNumber
		sub	r1,#1
		mov	r3,#0
		strb	r3,[r4]
		bl	.DrawNumber
		pop	{r3-r4,PC}
@***********************************************************************************************************
.align 4
numbers_base:	.word 100000000,10000000,1000000,100000,10000,1000,100,10,1
.align 2
font_color:	.word	0
.align 2
font:
.incbin	"font.bin"
@***********************************************************************************************************
@***********************************[ Graph procedures & functions ]****************************************
@***********************************************************************************************************
.align 2						@  in: r0=A r1=B	C=A/B mod D
.DivMod:	push	{r2,LR}				@ out: r0=C r1=D
		mov	r2,r1
		mov	r1,r0
		mov	r0,#0
_DivModLoop:	cmp	r1,r2
		blo	_endDivMod
		sub	r1,r2
		add	r0,#1
		b	_DivModLoop
_endDivMod:	pop	{r2,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y
.GetOfs:	push	{r1-r2,LR}			@ out: r0=screen ofs
		mov	r2,#96
		mul	r1,r2
		add	r0,r1
		ldr	r2,vidmem
		add	r0,r2
		pop	{r1-r2,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y r2=length r3=color
.HLine:		push	{r0-r3,LR}			@ out: none
		bl	.GetOfs
_HLineLoop:	strb	r3,[r0]
		add	r0,#1
		sub	r2,#1
		cmp	r2,#0
		bne	_HLineLoop
		pop	{r0-r3,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y r2=length r3=color
.VLine:		push	{r0-r3,LR}			@ out: none
		bl	.GetOfs
_VLineLoop:	strb	r3,[r0]
		add	r0,#96
		sub	r2,#1
		cmp	r2,#0
		bne	_VLineLoop
		pop	{r0-r3,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y
.GetSpriteOfs:	push	{r1-r2,LR}			@ out: r0=sprite number
		mov	r2,#19
		mul	r1,r2
		add	r0,r1
		pop	{r1-r2,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=x r1=y
.GetBrickOfs:	push	{r1-r3,LR}			@ out: r0=screen ofs
		mov	r2,#96
		mov	r3,#5
		mul	r1,r2
		mul	r1,r3
		mul	r0,r3
		add	r0,r1
		ldr	r1,vidmem
		add	r0,r1
		pop	{r1-r3,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r2=sprite
.UpdateAnim:	push	{r3-r4,LR}			@ out: none
		ldrb	r3,[r2]
		sub	r3,#1
		ldrb	r4,[r2,#1]
		add	r4,#1
		cmp	r4,r3
		ble	_UpdateNext
		mov	r4,#0
_UpdateNext:	strb	r4,[r2,#1]
		pop	{r3-r4,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=screen ofs r1=sprite r2=sprite ofs
.DrawSprite:	push	{r0-r7,LR}			@ out: none
		ldrb	r3,[r1]
		ldrb	r4,[r1,#1]
		add	r1,r2
		mov	r5,r1
		mov	r7,r3
		mov	r6,#4
		ldrb	r1,[r5,#2]
_loopS:		mov	r2,#3
		and	r2,r1
		lsr	r1,#2
		strb	r2,[r0]
		add	r0,#1
		sub	r6,#1
		bne	_nextS
		mov	r6,#4
		add	r5,#1
		ldrb	r1,[r5,#2]
_nextS:		sub	r3,#1
		bne	_loopS
		mov	r3,r7
		add	r0,#96
		sub	r0,r7
		sub	r4,#1
		bne	_loopS
		pop	{r0-r7,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2						@  in: r0=screen ofs r1=sprite
.DrawAnim:	push	{r1-r4,LR}			@ out: none
		ldrb	r3,[r1,#1]
		add	r1,#2
		mov	r2,#7
		mul	r2,r3
		bl	.DrawSprite
		pop	{r1-r4,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2
vidmem:		.word	videoMem
@***********************************************************************************************************
@***********************************************[ Events ]**************************************************
@***********************************************************************************************************
.align 1
.CallOldEvent:	push	{r5}
		ldr	r5,OldEvents
		lsl	r4,r4,#3
		add	r4,r4,#12
		ldr	r4,[r5,r4]
		pop	{r5}
		bx	r4
.SetNewEvent:	ldr	r2,NewEvents
		lsl	r0,r0,#3
		add	r0,r0,#12
		str	r1,[r2,r0]
		mov	PC,LR
.HookEvents:	push	{r4-r5,LR}
		mov	r4,r0
		mov	r0,#0xA4			@ 2*41*8 = 0x290
		lsl	r0,r0,#2
		mov	r1,#8
		add	r0,r0,r1
		bl	.malloc
		adr	r1,OldEvents
		str	r0,[r1]
		ldr	r1,[r4,#0x10]
		mov	r2,#0xFF
		add	r2,r2,#0x49
		bl	.memcpy
		mov	r1,r0
		mov	r2,#0xFF
		add	r2,r2,#0x49
		add	r0,r0,r2
		adr	r5,NewEvents
		str	r0,[r5]
		mov	r5,r0
		bl	.memcpy
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
							@ Here you can set any event handler
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
		mov	r0,#0x15
		adr	r1,.NewEvent_Key
		add	r1,r1,#1
		bl	.SetNewEvent
		mov	r0,#0x1A
		adr	r1,.NewEvent_Destroy
		add	r1,r1,#1
		bl	.SetNewEvent
		mov	r0,#0x13
		adr	r1,.NewEvent_Paint
		add	r1,r1,#1
		bl	.SetNewEvent
		mov	r0,#0x29
		adr	r1,.MyTimerFunc
		add	r1,r1,#1
		bl	.SetNewEvent
		str	r5,[r4,#0x10]
		pop	{r4-r5,PC}
.UnhookEvents:	push	{LR}
		ldr	r0,OldEvents
		bl	.free
		pop	{PC}
.align 2
OldEvents:	.word 0
NewEvents:	.word 0
@***********************************************************************************************************
@************************************************[ Main ]***************************************************
@***********************************************************************************************************
.main:		push	{r4-r7,LR}
		mov	r6,r0
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
		bl	.InitGame			@ You can place some initialization code here,
		cmp	r0,#0				@ but you can use OnCreate event too
		beq	.exit
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
		bl	.GetWindowManager
		mov	r5,r0
		mov	r0,#0x70
		bl	.malloc
		mov	r4,r0
		mov	r0,r6
		cmp	r0,#0
		bne	.skip_wnd
		mov	r0,#0x7D
		lsl	r0,r0,#4
		bl	.GetWindowById
.skip_wnd:	mov	r2,r5
		mov	r1,r0
		mov	r0,r4
		bl	.cWindowWidget_Create
		mov	r0,r4
		bl	.HookEvents
		adr	r0,TimerFuncs
		str	r0,[r4,#0x4C]
		adr	r1,.MyTimerFunc
		add	r1,#1
		str	r1,[r0,#0xC]
		adr	r1,.NewEvent_Destroy
		add	r1,#1
		str	r1,[r0,#0x14]
		mov	r0,#0x50
		add	r0,r4,r0
		mov	r1,#0x4C
		add	r1,r4,r1
		bl	.Time_CreateServer
		mov	r0,#0x50
		add	r0,r4,r0
		ldr	r1,Interval
		mov	r2,#1
		bl	.Time_SetInterval		@ Init timer
		mov	r0,r4
.exit:		pop	{r4-r7,PC}
@***********************************************************************************************************
@*****************************************[ New event handlers ]********************************************
@***********************************************************************************************************
.align 2
.NewEvent_Key:	push	{r4,LR}				@@@@@@@@@@@@@@@@@@@ OnKeyPressed @@@@@@@@@@@@@@@@@@@
		push	{r0-r7}
		mov	r3,r1
		ldrh	r1,[r3,#0xE]
		ldrh	r0,[r3,#0xC]
							@ Your keyhandler code here
							@  r1 - Key scancode
							@       0x30 .. 0x39 - "0".."9"
							@       0x23 - "#"
							@       0x2a - "*"
							@  r0 - Event type (101h,106h,107h,...)
							@          0x106 - key pressed
							@          0x107 - key unpressed
							@        0x101 & scan 0x09 - RedButton pressed
							@        0x101 & scan 0x56 - CenterKey pressed
							@        0x101 & scan 0x08 - CenterKey holded
							@        0x101 & scan 0x07 - CenterKey unpressed
							@        0x101 & scan 0x0b - GreenButton pressed
							@        0x101 & scan 0x03 - JogUp
							@        0x101 & scan 0x05 - JogDown
							@        0x101 & scan 0x56 - JogPress
							@        0x101 & scan 0x4d - JogRelase
							@        0x101 & scan 0x0c - JogHold
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
		bl	.KeyboardScan
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
		pop	{r0-r7}               		@ In every handler you NEED to pass
		mov	r4,#0x15              		@ old registers r0-r3 to CallOldEvent
		bl	.CallOldEvent
		pop	{r4,PC}
.align 2
.NewEvent_Destroy:					@@@@@@@@@@@@@@@@@@@@ OnDestroy @@@@@@@@@@@@@@@@@@@@@
		push	{r4,LR}
		push	{r0-r3}
		mov	r1,#0x50
		add	r0,r0,r1
		mov	r1,#2				@ Destroy timer
		bl	.Time_DestroyServer
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
		bl	.DeInitGame			@ Place your deinitialization here
							@ (some free(), etc)
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
		pop	{r0-r3}
		mov	r4,#0x1A
		bl	.CallOldEvent
		bl	.UnhookEvents
		pop	{r4,PC}
.align 2
.NewEvent_Paint:
		push	{r4-r5,LR}
	@	mov	r5,r0
	@	mov	r4,#0x13
	@	bl	.CallOldEvent			@ for widget this clear screen to color 3
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
		bl	.DrawGame
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
		pop	{r4-r5,PC}			@ After return, screen is repainted, you don't
							@ need to call Repaint in this Paint_event
.align 2
.MyTimerFunc:	push	{r4-r6,lr}			@@@@@@@@@@@@@@@@@@@@@@ OnTimer @@@@@@@@@@@@@@@@@@@@@
		mov	r4,r0
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
							@ Your timer handler code here
@ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | |
@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*@*
		mov	r0,r4				@ This will repaint the window using Paint event
		bl	.WindowRepaint			@ Use this metod for drawing, don't draw in timer
		mov	r0,#0x50
		add	r0,r4,r0
		bl	.Time_Repeat			@ Refresh timer - only one parameter r4+0x50
		pop	{r4-r6,pc}
.align 2
Interval:	.word	30				@ Not in ms - smaller -> shorter time
TimerFuncs:	.word	0x4C				@ Functions base for timer event structure
		.word	0
		.word	0xFFB4
		.word	0x0
		.word	0xFFB4
		.word	0x0
@***********************************************************************************************************
@************************************[ Keyboard and game logic unit ]***************************************
@***********************************************************************************************************
.align 2
.KeyboardScan:	push	{r0-r6,LR}
		mov	r3,#2
		add	r3,#0xFF
		cmp	r0,r3
		bne	_JogNotUsed
		cmp	r1,#0x05
		beq	_NextLevel
		cmp	r1,#0x03
		beq	_PervousLevel
_JogNotUsed:	mov	r3,#7
		add	r3,#0xFF
		cmp	r0,r3
		bne	_endKeyScan
		cmp	r1,#0x31
		beq	_Help
		adr	r4,xy01
		ldrb	r2,[r4]
		ldrb	r3,[r4,#1]
		cmp	r1,#0x32
		beq	_Up
		cmp	r1,#0x34
		beq	_Left
		cmp	r1,#0x36
		beq	_Right
		cmp	r1,#0x35
		beq	_Down
		cmp	r1,#0x38
		beq	_Down
		cmp	r1,#0x2A
		beq	_Reset
		cmp	r1,#0x23
		beq	_Ground
_endKeyScan:	pop	{r0-r6,PC}
@-----------------------------------------------------------------------------------------------------------
_H_deactivate:	mov	r1,#0
		strb	r1,[r0]
		b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_N_deactivate:	mov	r1,#0
		strb	r1,[r0,#1]
		b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_NextLevel:	adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#1
		beq	_H_deactivate
		ldrb	r1,[r0,#1]
		cmp	r1,#1
		beq	_N_deactivate
		bl	.NextLevel
		b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_PervousLevel:	adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#1
		beq	_H_deactivate
		ldrb	r1,[r0,#1]
		cmp	r1,#1
		beq	_N_deactivate
		bl	.PervousLevel
		b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_Help:		adr	r0,HnN_activate
		mov	r1,#1
		ldrb	r2,[r0]
		add	r2,#1
		and	r2,r1
		strb	r2,[r0]
		b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_Reset:		adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#1
		beq	_H_deactivate
		ldrb	r1,[r0,#1]
		cmp	r1,#1
		beq	_N_deactivate
		bl	.CopyLevel
		b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_Ground:	push	{r0-r2}
		adr	r2,bgTemp
		ldrb	r0,[r2]
		adr	r1,bgNum
		ldrb	r1,[r1]
		add	r0,#1
		cmp	r0,r1
		bne	_GroundLoop
		mov	r0,#0
_GroundLoop:	strb	r0,[r2]
		pop	{r0-r2}
		b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_Up:		adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#1
		beq	_H_deactivate
		ldrb	r1,[r0,#1]
		cmp	r1,#1
		beq	_N_deactivate
		sub	r3,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	_MoveLogic
@-----------------------------------------------------------------------------------------------------------
_Left:		adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#1
		beq	_H_deactivate
		ldrb	r1,[r0,#1]
		cmp	r1,#1
		beq	_N_deactivate
		sub	r2,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	_MoveLogic
@-----------------------------------------------------------------------------------------------------------
_Right:		adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#1
		beq	_H_deactivate
		ldrb	r1,[r0,#1]
		cmp	r1,#1
		beq	_N_deactivate
		add	r2,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	_MoveLogic
@-----------------------------------------------------------------------------------------------------------
_Down:		adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#1
		beq	_H_deactivate
		ldrb	r1,[r0,#1]
		cmp	r1,#1
		beq	_N_deactivate
		add	r3,#1
		strb	r2,[r4,#2]
		strb	r3,[r4,#3]
		b	_MoveLogic
@-----------------------------------------------------------------------------------------------------------
_MoveLogic:	ldr	r5,CurrentLevel
		adr	r2,xy01
		ldrb	r0,[r2,#2]
		ldrb	r1,[r2,#3]
		bl	.GetSpriteOfs
		ldrb	r1,[r5,r0]
		cmp	r1,#0
		beq	_FreeSpace
		cmp	r1,#2
		beq	_ChestSpace
		cmp	r1,#6
		beq	_ChestOKSpace
		cmp	r1,#3
		beq	_FreeSpace
_endMoveLogic:	b	_endKeyScan
@-----------------------------------------------------------------------------------------------------------
_AddMoves:	adr	r0,moves
		ldr	r1,[r0]
		add	r1,#1
		str	r1,[r0]
		b	_endMoveLogic
@-----------------------------------------------------------------------------------------------------------
_FreeSpace:	adr	r2,xy01
		ldrb	r0,[r2,#2]
		ldrb	r1,[r2,#3]
		strb	r0,[r2]
		strb	r1,[r2,#1]
		b	_AddMoves
@-----------------------------------------------------------------------------------------------------------
_ChestSpace:	adr	r6,xy01
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		ldrb	r2,[r6]
		ldrb	r3,[r6,#1]
		add	r0,r0
		sub	r0,r2
		add	r1,r1
		sub	r1,r3
		bl	.GetSpriteOfs
		ldrb	r4,[r5,r0]
		cmp	r4,#0
		beq	_Chest1
		cmp	r4,#3
		bne	_endMoveLogic
		mov	r4,#6
		b	_Chest2
_Chest1:	mov	r4,#2
_Chest2:	strb	r4,[r5,r0]
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		push	{r0}
		bl	.GetSpriteOfs
		mov	r4,#0
		strb	r4,[r5,r0]
		pop	{r0}
		strb	r0,[r6]
		strb	r1,[r6,#1]
		b	_AddMoves
@-----------------------------------------------------------------------------------------------------------
_ChestOKSpace:	adr	r6,xy01
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		ldrb	r2,[r6]
		ldrb	r3,[r6,#1]
		add	r0,r0
		sub	r0,r2
		add	r1,r1
		sub	r1,r3
		bl	.GetSpriteOfs
		ldrb	r4,[r5,r0]
		cmp	r4,#0
		beq	_ChestOK1
		cmp	r4,#3
		bne	_endMoveLogic
		mov	r4,#6
		b	_ChestOK2
_ChestOK1:	mov	r4,#2
_ChestOK2:	strb	r4,[r5,r0]
		ldrb	r0,[r6,#2]
		ldrb	r1,[r6,#3]
		push	{r0}
		bl	.GetSpriteOfs
		mov	r4,#3
		strb	r4,[r5,r0]
		pop	{r0}
		strb	r0,[r6]
		strb	r1,[r6,#1]
		b	_AddMoves
@***********************************************************************************************************
@*******************************************[ Graphics unit ]***********************************************
@***********************************************************************************************************
.align 2
.DrawGame:	push	{r0-r7,LR}
		bl	.DrawLabyrinth
		adr	r1,xy01
		ldrb	r0,[r1]
		ldrb	r1,[r1,#1]
		bl	.GetBrickOfs
		adr	r1,player
		bl	.DrawAnim
		bl	.DrawBoxnMenu
		bl	.UpdateSprites
		adr	r0,HnN_activate
		ldrb	r1,[r0]
		cmp	r1,#0
		bne	_txtHelp
		ldrb	r1,[r0,#1]
		cmp	r1,#0
		bne	_txtNext
		b	_txtEnd
_txtHelp:	mov	r0,#7
		mov	r1,#3
		adr	r2,help_txt
		bl	.DrawMaskedText
		b	_txtEnd
_txtNext:	mov	r0,#5
		mov	r1,#28
		adr	r2,next_txt01
		bl	.DrawMaskedText
		add	r1,#7
		adr	r2,next_txt02
		bl	.DrawMaskedText
		add	r0,#64
		ldr	r2,moves_print
		bl	.DrawMaskedNum
		mov	r0,#15
		add	r1,#14
		adr	r2,next_txt03
		bl	.DrawMaskedText
		add	r0,#57
		ldr	r2,LevelNumber
		add	r2,#1
		bl	.DrawMaskedNum
_txtEnd:	adr	r0,LevelDone
		ldrb	r0,[r0]
		cmp	r0,#0
		bne	_exitDrawGame
		adr	r0,HnN_activate
		mov	r1,#1
		strb	r1,[r0,#1]
		ldr	r0,moves
		adr	r1,moves_print
		str	r0,[r1]
		ldr	r0,moves_hi
		ldr	r1,moves
		cmp	r0,r1
		ble	_NotHiScore
		mov	r0,r1
_NotHiScore:	bl	.SaveHiscore
		adr	r0,Levels
		ldrb	r0,[r0]
		adr	r1,lev_hi
		adr	r2,LevelNumber
		ldrb	r2,[r2]
		add	r2,#2
		cmp	r2,r0
		ble	_NotLastLevel
		mov	r2,r0
_NotLastLevel:	strb	r2,[r1]
		bl	.NextLevel
		adr	r0,LevelDone
		add	r1,#0xFF
		strb	r1,[r0]
_exitDrawGame:	pop	{r0-r7,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2
.DrawLabyrinth:	push	{r0-r5,LR}
		adr	r0,LevelDone
		mov	r1,#0
		strb	r1,[r0]
		ldr	r5,CurrentLevel
		mov	r0,#0
		mov	r1,#0
		mov	r4,#0
_LabNextRow:	mov	r3,#0
		push	{r0-r1}
		bl	.GetOfs
_LabNextSymbol:	ldrb	r2,[r5]
		cmp	r2,#0
		beq	_DrawFloor
		cmp	r2,#1
		beq	_DrawBrick
		cmp	r2,#2
		beq	_DrawChest
		cmp	r2,#3
		beq	_DrawPlace
		cmp	r2,#4
		beq	_DrawGround
		cmp	r2,#5
		beq	_SavePlayerPos
		cmp	r2,#6
		beq	_DrawChestOK
_ContinueDraw:	add	r5,#1
		add	r0,#5
		add	r3,#1
		cmp	r3,#19
		bne	_LabNextSymbol
		pop	{r0-r1}
		add	r1,#5
		add	r4,#1
		cmp	r4,#16
		bne	_LabNextRow
		pop	{r0-r5,PC}
_DrawFloor:	adr	r1,floor
		mov	r2,#0
		bl	.DrawSprite
		b	_ContinueDraw
_DrawBrick:	adr	r1,brick
		mov	r2,#0
		bl	.DrawSprite
		b	_ContinueDraw
_DrawChest:	adr	r1,chest
		mov	r2,#0
		bl	.DrawSprite
		adr	r2,LevelDone
		ldrb	r1,[r2]
		add	r1,#1
		strb	r1,[r2]
		b	_ContinueDraw
_DrawPlace:	adr	r1,place
		bl	.DrawAnim
		b	_ContinueDraw
_DrawGround:	bl	.GroundCalc
		mov	r1,r2
		bl	.DrawAnim
		b	_ContinueDraw
_SavePlayerPos:	adr	r2,xy01
		strb	r3,[r2]
		strb	r4,[r2,#1]
		mov	r1,#0
		strb	r1,[r5]
		b	_ContinueDraw
_DrawChestOK:	adr	r1,chestOK
		bl	.DrawAnim
		b	_ContinueDraw
@-----------------------------------------------------------------------------------------------------------
.align 2
.UpdateSprites:	push	{r2,LR}
		adr	r2,player
		bl	.UpdateAnim
		bl	.GroundCalc
		bl	.UpdateAnim
		adr	r2,chestOK
		bl	.UpdateAnim
		adr	r2,place
		bl	.UpdateAnim
		pop	{r2,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2
.GroundCalc:	push	{r0-r1,LR}
		adr	r2,bg1
		adr	r0,bgTemp
		ldrb	r0,[r0]
		adr	r1,bgSize
		ldrb	r1,[r1]
		mul	r0,r1
		add	r2,r0
		pop	{r0-r1,PC}
@-----------------------------------------------------------------------------------------------------------
.CopyLevel:	push	{r0-r4,LR}
		adr	r0,Level1
		ldr	r1,LevelNumber
		mov	r2,#152
		add	r3,r2,#4
		mul	r1,r3
		add	r0,r1
		ldr	r1,[r0]
		adr	r3,moves_hi
		str	r1,[r3]
		add	r0,#4
		ldr	r1,CurrentLevel
		mov	r4,#15
_CopyLevelLoop:	ldrb	r3,[r0]
		and	r3,r4
		strb	r3,[r1]
		add	r1,#1
		ldrb	r3,[r0]
		lsr	r3,r3,#4
		and	r3,r4
		strb	r3,[r1]
		add	r1,#1
		add	r0,#1
		sub	r2,#1
		cmp	r2,#0
		bne	_CopyLevelLoop
		adr	r0,moves
		mov	r1,#0
		str	r1,[r0]
		adr	r0,xy01
		strb	r1,[r0]
		strb	r1,[r0,#1]
		strb	r1,[r0,#2]
		strb	r1,[r0,#3]
		pop	{r0-r4,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2
xy01:		.byte	0,0,0,0
.align 2
HnN_activate:	.byte	0,0
.align 2
bgNum:		.byte	3
.align 2
bgTemp:		.byte	0
@-----------------------------------------------------------------------------------------------------------
.align 2
.NextLevel:	push	{r0-r2,LR}
		adr	r0,LevelNumber
		adr	r1,lev_hi
		ldrb	r2,[r0]
		ldrb	r1,[r1]
		sub	r1,#1
		cmp	r2,r1
		beq	_exitNextLevel
		add	r2,#1
		strb	r2,[r0]	
		bl	.CopyLevel
		pop	{r0-r2,PC}
_exitNextLevel:	strb	r1,[r0]
		bl	.CopyLevel
		pop	{r0-r2,PC}
@-----------------------------------------------------------------------------------------------------------
.PervousLevel:	push	{r0-r1,LR}
		adr	r0,LevelNumber
		ldrb	r1,[r0]
		cmp	r1,#0
		beq	_exitPervLevel
		sub	r1,#1
		strb	r1,[r0]
		bl	.CopyLevel
		pop	{r0-r1,PC}
_exitPervLevel:	mov	r1,#0
		strb	r1,[r0]
		bl	.CopyLevel
		pop	{r0-r1,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2
.DrawBoxnMenu:	push	{r0-r4,LR}
		mov	r3,#0
		mov	r0,#0
		mov	r1,#0
		mov	r2,#96
		bl	.HLine
		mov	r1,#91
		bl	.HLine
		mov	r1,#80
		bl	.HLine
		mov	r1,#0
		mov	r2,#91
		bl	.VLine
		mov	r0,#95
		bl	.VLine
		mov	r4,#10
		mov	r0,#1
		mov	r1,#81
		mov	r2,#94
		mov	r3,#2
_BoxLoop:	bl	.HLine
		add	r1,#1
		sub	r4,#1
		cmp	r4,#0
		bne	_BoxLoop
		mov	r0,#1
		mov	r1,#83
		adr	r2,level_txt
		bl	.DrawString
		add	r0,#8
		adr	r2,LevelNumber
		ldrb	r2,[r2]
		add	r2,#1
		bl	.DrawNumber
		mov	r0,#22
		adr	r2,moves_txt
		bl	.DrawString
		add	r0,#11
		adr	r2,moves
		ldr	r2,[r2]
		bl	.DrawNumber
		mov	r0,#58
		adr	r2,moves_hi_txt
		bl	.DrawString
		add	r0,#12
		ldr	r2,moves_hi
		bl	.DrawNumber
		pop	{r0-r4,PC}
@***********************************************************************************************************
@********************************[Initialization and Deinitialization unit ]********************************
@***********************************************************************************************************
.align 2
.InitGame:	push	{r1,LR}
		bl	.GameSectionGet
		adr	r0,LevelNumber
		mov	r1,#0
		strb	r1,[r0]
		ldr	r0,LevelSize
		bl	.malloc
		adr	r1,CurrentLevel
		str	r0,[r1]
		bl	.CopyLevel
		pop	{r1,PC}
@-----------------------------------------------------------------------------------------------------------
.align 2
.DeInitGame:	push	{r0,LR}
		ldr	r0,CurrentLevel
		bl	.free
		bl	.Save
		pop	{r0,PC}
@***********************************************************************************************************
@**********************************[ Save game procedures & functions ]*************************************
@***********************************************************************************************************
.align 2
.GameSectionGet:push	{r0-r1,LR}
		ldr	r0,[r0,#0x68]
		adr	r1,game_section
		str	r0,[r1]
		pop	{r0-r1,PC}
.align 2
.Save:		push	{r0-r4,LR}
		ldr	r0,game_section
		mov	r1,#2
		bl	.NVMGetSection
		mov	r4,r0
		ldr	r1,game_length
		adr	r2,game_start_addr
		ldr	r3,[r2]
		sub	r2,r3
		bl	.NVMWriteSection
		mov	r0,r4
		bl	.NVMCloseSection
		pop	{r0-r4,PC}
.align 2
.SaveHiscore:	push	{r1-r4,LR}			@ r0=hiscore
		adr	r4,Level1
		ldr	r1,LevelNumber
		mov	r2,#152
		add	r3,r2,#4
		mul	r1,r3
		add	r4,r1
		str	r0,[r4]
		pop	{r1-r4,PC}
.align 2
game_section:	.word	0
game_length:	.word	game_end-game_start
game_start_addr:.word	game_start_addr-game_start
@***********************************************************************************************************
@***************************************[ Game params, text, sprites ]**************************************
@***********************************************************************************************************
.align 2
moves:		.word	0
.align 2
moves_hi:	.word	0
.align 2
moves_print:	.word	0
.align 2
bgSize:		.byte	39
.align 2
LevelDone:	.byte	0xFF
.align 2
LevelNumber:	.byte	0
.align 2
CurrentLevel:	.word	0
.align 2
LevelSize:	.word	304
.align 2
Levels:		.byte	lev
.align 2
lev_hi:		.byte	1
.align 2
next_txt01:	.string	"Level Completed!"
.align 2
next_txt02:	.string "Moves made:"
.align 2
next_txt03:	.string "Next level:"
.align 2
help_txt:	.string	" -=HELP PAGE=-/Control keys:/1-this HELP page/2-UP, 8,5-DOWN,/4-LEFT, 6-RIGHT,/*-RESET level,/#-CHANGE back-/ground texture,/JogDial-CHANGE/level./  -=Slayer=-"
.align 2
level_txt:	.string "L:"
.align 2
moves_txt:	.string "M:"
.align 2
moves_hi_txt:	.string	"Hi:"
.align 2
player:		.byte	6,0,5,5
		.byte	0x03,0x03,0x00,0x00,0x00,0x03,0x03
		.byte	0x03,0x53,0x41,0x05,0x15,0x03,0x03
		.byte	0x03,0xA3,0x82,0x0A,0x2A,0x03,0x03
		.byte	0x03,0xF3,0xC3,0x0F,0x3F,0x03,0x03
		.byte	0x03,0xA3,0x82,0x0A,0x2A,0x03,0x03
		.byte	0x03,0x53,0x41,0x05,0x15,0x03,0x03
.align 2
floor:		.byte	5,5
		.byte	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
.align 2
brick:		.byte	5,5
		.byte	0x09,0x64,0xA5,0x2A,0x24,0x95,0xFD
.align 2
chest:		.byte	5,5
		.byte	0x54,0xC5,0xD7,0x5C,0x4F,0x55,0xFC
.align 2
place:		.byte	4,0,5,5
		.byte	0xFF,0x0F,0x3E,0xF8,0xEA,0xFF,0xFF
		.byte	0xFF,0x2F,0xBC,0xF0,0xEA,0xFF,0xFF
		.byte	0xFF,0xAF,0xBE,0xF0,0xC2,0xFF,0xFF
		.byte	0xFF,0xAF,0x3E,0xF8,0xE0,0xFF,0xFF
.align 2
chestOK:	.byte	4,0,5,5
		.byte	0x54,0xC5,0xD7,0x5C,0x4F,0x55,0xFC
		.byte	0x55,0xF5,0x07,0x40,0x7F,0x55,0xFD
		.byte	0x55,0xF4,0xD4,0x5C,0x7C,0x54,0xFD
		.byte	0x45,0x35,0xD7,0x5C,0x73,0x45,0xFD
.align 2
bg1:		.byte	5,0,5,5
		.byte	0x00,0xF0,0xCF,0x3F,0xFF,0xFC,0xFF
		.byte	0xF3,0x03,0x30,0xFF,0xFC,0xF3,0xFF
		.byte	0xCF,0x3F,0x0F,0xC0,0xF3,0xCF,0xFF
		.byte	0x3F,0xFF,0xFC,0x33,0x00,0x3F,0xFF
		.byte	0xFF,0xFC,0xF3,0xCF,0x3F,0x00,0xFC
bg2:		.byte	5,0,5,5
		.byte	0xFF,0xFF,0xFF,0xFC,0xFF,0xFF,0xFF
		.byte	0xFF,0x0F,0x3C,0xF0,0xC0,0xFF,0xFF
		.byte	0x00,0x00,0x00,0x00,0x00,0x00,0xFC
		.byte	0xFF,0x0F,0x3C,0xF0,0xC0,0xFF,0xFF
		.byte	0xFF,0xFF,0xFF,0xFC,0xFF,0xFF,0xFF
bg3:		.byte	1,0,5,5
		.byte	0xAA,0xFA,0xEB,0xAF,0xBF,0xAA,0xFE
.include "levels.h"
